import sys
import re
load("verify.sage")
dimension=6405

#load regularity ineqaulities
print 'loading "for each F \in O_6, the expression F = \sum_{G \in O_8} a_G * G"'
sixpoint_densities=[]
f=open("6point_densities")

for line in f.readlines():
	if (line==''): break
	ineq=vector( map(QQ, re.split(' ', line[:-1])) )
	sixpoint_densities.append(ineq)
f.close()


print 'loading "8! / ((4-|sigma|/2)!^2) * [[A^sigma x B^sigma]]_sigma" coefficients for Cauchy-Schwarz calculus'
CS_tables=[]
for i in xrange(24):
	CS_tables.append(load_CS_table('CS%d'%i))


# no verctor with F >= 1/32 for all F \in O_6
print "proving no vector can have F>=1/32 for all F \in O_6"
problem_filename="inbal-132"
f=open(problem_filename)

# we compute \sum x_i*F_i >= 0
proven_inequality= compute_nonnegative_inequality(f)
f.close()

sixpoint_weights=[16511/512,0,0,0,0,0,0,0,0,60574331/32768,0,0,0,2202839/32768,0,0,0,0,16680307/32768,46526467/32768] 
for i in xrange(len(sixpoint_densities)):
	v=map(lambda x: sixpoint_weights[i]*(x - 1/32), sixpoint_densities[i])
	proven_inequality+=vector(v)

val=max(proven_inequality)
print "assuming F >= 1/32 for all F \in O_6, it holds that c*\sum_{F \in O_8} F >=0 for c =",val,"~",float(val), "; a contradiction"



# no verctor with F <= 1/18 for all F \in O_6
print "proving no vector can have F<=1/18 for all F \in O_6"
problem_filename="inbal-118"
f=open(problem_filename)
# we compute \sum x_i*F_i >= 0
proven_inequality= compute_nonnegative_inequality(f)
f.close()

sixpoint_weights=[83051/1024,133071/1024,140047/1024,58671/1024,58671/1024,18695/64,34399/512,33243/512,33243/512,0,0,0,105011/512,0,132739/1024,132739/1024,10875/1024,10875/1024,0,0]
for i in xrange(len(sixpoint_densities)):
	v=map(lambda x: sixpoint_weights[i]*(1/18 - x), sixpoint_densities[i])
	proven_inequality+=vector(v)

val=max(proven_inequality)
print "assuming F <= 1/18 for all F \in O_6, it holds that c*(\sum_{G \in O_8} G) >=0 for c =",val,"~",float(val), "; a contradiction"
