#load Cauchy-Schwarz tables for a type sigma
def load_CS_table(filename):
	f=open(filename)
	checksum=int(f.readline())

	table=[]
	i=0

	while True: 
		line=f.readline()
		if (line==''): break
		size=int(line[:-1])
		item={}
		for j in xrange(size):
			line=f.readline()
			(A,B,value)=map(int,str.split(line[:-1]))
			item[(A,B)]=value
		table.append(item)
		i+=size

	f.close()
	if (checksum!=i):
		sys.stderr.write("Checksum error while loading CS table %s\n"%filename)
		sys.exit(1)		

	return table
#load_CS_table


def add_square(CS_table, square_vector):
	result=vector(QQ,dimension*[0])
	for i in xrange(dimension):
		for (A,B) in CS_table[i]:
			result[i]+=CS_table[i][(A,B)] * square_vector[A] * square_vector[B] * (1+(A!=B))
	return result
#add_square

def compute_nonnegative_inequality(f):
	nonneg_inequality=vector(QQ, dimension*[0])
	square_counts={}
	while True:
		line=f.readline()
		if (line==''): break
		parseline=re.match("^(\d+) (\d+/\d+) \((.*)\)\n", line)
		index=int(parseline.groups()[0])
		weight=QQ(parseline.groups()[1])
		square_vector=map(QQ, re.split(' ', parseline.groups()[2]))
		nonneg_inequality+=weight * add_square(CS_tables[index], square_vector)
		if (not square_counts.has_key(index)):
			square_counts[index]=1
		else:
			square_counts[index]+=1
	
	print "  Number of squares used: %s ; total number: %d" %(square_counts, sum(square_counts.values()))
	return nonneg_inequality
#compute_nonnegative_inequality
